  len=instrbuf.s.len/sizeof(p_instr);
  instructions=(p_instr *)instrbuf.s.str;
  instrbuf.s.str=0;
  fifo_len=0;
  init_bytecode();

  for(eye=0;eye<len;)
  {
    INT32 current_line;
    struct pike_string *current_file;

    switch(opcode(0))
    {
    case F_POP_N_ELEMS:
      switch(argument(0))
      {
      case 0:
        /* POP_N_ELEMS (0) :  */
        {
          pop_n_opcodes(1);
          continue;
        }
        break;

      case 1:
        /* POP_N_ELEMS(1) : POP_VALUE */
        {
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(1);
          insert2(F_POP_VALUE);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      default:
        switch(opcode(1))
        {
        case F_POP_VALUE:
          /* POP_N_ELEMS POP_VALUE : POP_N_ELEMS ($1a + 1) */
          {
            INT32 arg0=argument(0) + 1;
            copy_shared_string(current_file,instr(0)->file);
            current_line=instr(0)->line;
            pop_n_opcodes(2);
            insert(F_POP_N_ELEMS,arg0);
            fifo_len+=1;
            free_string(current_file);
            debug();
            continue;
          }
          break;

        case F_POP_N_ELEMS:
          /* POP_N_ELEMS POP_N_ELEMS : POP_N_ELEMS ($1a + $2a) */
          {
            INT32 arg0=argument(0) + argument(1);
            copy_shared_string(current_file,instr(0)->file);
            current_line=instr(0)->line;
            pop_n_opcodes(2);
            insert(F_POP_N_ELEMS,arg0);
            fifo_len+=1;
            free_string(current_file);
            debug();
            continue;
          }
          break;

        }
      }
      break;

    case F_GLOBAL_LVALUE:
      switch(opcode(1))
      {
      case F_DEC_AND_POP:
        /* GLOBAL_LVALUE DEC_AND_POP GLOBAL($1a): GLOBAL_LVALUE($1a) DEC */
        if(F_GLOBAL==opcode(2) && (argument(0))==argument(2))
        {
          INT32 arg0=argument(0);
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(3);
          insert(F_GLOBAL_LVALUE,arg0);
          insert2(F_DEC);
          fifo_len+=2;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      case F_INC_AND_POP:
        /* GLOBAL_LVALUE INC_AND_POP GLOBAL($1a): GLOBAL_LVALUE($1a) INC */
        if(F_GLOBAL==opcode(2) && (argument(0))==argument(2))
        {
          INT32 arg0=argument(0);
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(3);
          insert(F_GLOBAL_LVALUE,arg0);
          insert2(F_INC);
          fifo_len+=2;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      }
      break;

    case F_DEC_LOCAL:
      /* DEC_LOCAL POP_VALUE : DEC_LOCAL_AND_POP ($1a) */
      if(F_POP_VALUE==opcode(1))
      {
        INT32 arg0=argument(0);
        copy_shared_string(current_file,instr(0)->file);
        current_line=instr(0)->line;
        pop_n_opcodes(2);
        insert(F_DEC_LOCAL_AND_POP,arg0);
        fifo_len+=1;
        free_string(current_file);
        debug();
        continue;
      }
      break;

    case F_NOT:
      switch(opcode(1))
      {
      case F_BRANCH_WHEN_ZERO:
        /* NOT BRANCH_WHEN_ZERO: BRANCH_WHEN_NON_ZERO($2a) */
        {
          INT32 arg0=argument(1);
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert(F_BRANCH_WHEN_NON_ZERO,arg0);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      case F_BRANCH_WHEN_NON_ZERO:
        /* NOT BRANCH_WHEN_NON_ZERO: BRANCH_WHEN_ZERO($2a) */
        {
          INT32 arg0=argument(1);
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert(F_BRANCH_WHEN_ZERO,arg0);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      }
      break;

    case F_CONST_1:
      switch(opcode(1))
      {
      case F_NEGATE:
        /* CONST_1 NEGATE : CONST1 */
        {
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert2(F_CONST1);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      case F_XOR:
        /* CONST_1 XOR: COMPL */
        {
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert2(F_COMPL);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      case F_INDEX:
        /* CONST_1 INDEX: NEG_INT_INDEX (1) */
        {
          INT32 arg0=1;
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert(F_NEG_INT_INDEX,arg0);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      case F_DIVIDE:
        /* CONST_1 DIVIDE : NEGATE */
        {
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert2(F_NEGATE);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      case F_MULTIPLY:
        /* CONST_1 MULTIPLY : NEGATE */
        {
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert2(F_NEGATE);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      }
      break;

    case F_GE:
      switch(opcode(1))
      {
      case F_BRANCH_WHEN_ZERO:
        /* GE BRANCH_WHEN_ZERO: BRANCH_WHEN_LT ($2a) */
        {
          INT32 arg0=argument(1);
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert(F_BRANCH_WHEN_LT,arg0);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      case F_NOT:
        /* GE NOT: LT */
        {
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert2(F_LT);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      case F_BRANCH_WHEN_NON_ZERO:
        /* GE BRANCH_WHEN_NON_ZERO: BRANCH_WHEN_GE ($2a) */
        {
          INT32 arg0=argument(1);
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert(F_BRANCH_WHEN_GE,arg0);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      }
      break;

    case F_BRANCH:
      /* BRANCH !LABEL : BRANCH($1a) */
      if(F_LABEL!=opcode(1))
      {
        INT32 arg0=argument(0);
        copy_shared_string(current_file,instr(0)->file);
        current_line=instr(0)->line;
        pop_n_opcodes(2);
        insert(F_BRANCH,arg0);
        fifo_len+=1;
        free_string(current_file);
        debug();
        continue;
      }
      /* BRANCH LABEL ($1a) : LABEL ($1a) */
      if(F_LABEL==opcode(1) && (argument(0))==argument(1))
      {
        INT32 arg0=argument(0);
        copy_shared_string(current_file,instr(0)->file);
        current_line=instr(0)->line;
        pop_n_opcodes(2);
        insert(F_LABEL,arg0);
        fifo_len+=1;
        free_string(current_file);
        debug();
        continue;
      }
      break;

    case F_INC_LOCAL:
      /* INC_LOCAL POP_VALUE : INC_LOCAL_AND_POP ($1a) */
      if(F_POP_VALUE==opcode(1))
      {
        INT32 arg0=argument(0);
        copy_shared_string(current_file,instr(0)->file);
        current_line=instr(0)->line;
        pop_n_opcodes(2);
        insert(F_INC_LOCAL_AND_POP,arg0);
        fifo_len+=1;
        free_string(current_file);
        debug();
        continue;
      }
      break;

    case F_DEC:
      /* DEC POP_VALUE: DEC_AND_POP */
      if(F_POP_VALUE==opcode(1))
      {
        copy_shared_string(current_file,instr(0)->file);
        current_line=instr(0)->line;
        pop_n_opcodes(2);
        insert2(F_DEC_AND_POP);
        fifo_len+=1;
        free_string(current_file);
        debug();
        continue;
      }
      break;

    case F_LE:
      switch(opcode(1))
      {
      case F_BRANCH_WHEN_ZERO:
        /* LE BRANCH_WHEN_ZERO: BRANCH_WHEN_GT ($2a) */
        {
          INT32 arg0=argument(1);
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert(F_BRANCH_WHEN_GT,arg0);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      case F_NOT:
        /* LE NOT: GT */
        {
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert2(F_GT);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      case F_BRANCH_WHEN_NON_ZERO:
        /* LE BRANCH_WHEN_NON_ZERO: BRANCH_WHEN_LE ($2a) */
        {
          INT32 arg0=argument(1);
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert(F_BRANCH_WHEN_LE,arg0);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      }
      break;

    case F_NEGATE:
      switch(opcode(2))
      {
      case F_ADD:
        /* NEGATE CONST_1 ADD : COMPL */
        if(F_CONST_1==opcode(1))
        {
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(3);
          insert2(F_COMPL);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      case F_SUBTRACT:
        /* NEGATE CONST1 SUBTRACT : COMPL */
        if(F_CONST1==opcode(1))
        {
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(3);
          insert2(F_COMPL);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      }
      break;

    case F_DEC_LOCAL_AND_POP:
      /* DEC_LOCAL_AND_POP LOCAL ($1a) : DEC_LOCAL ($1a) */
      if(F_LOCAL==opcode(1) && (argument(0))==argument(1))
      {
        INT32 arg0=argument(0);
        copy_shared_string(current_file,instr(0)->file);
        current_line=instr(0)->line;
        pop_n_opcodes(2);
        insert(F_DEC_LOCAL,arg0);
        fifo_len+=1;
        free_string(current_file);
        debug();
        continue;
      }
      break;

    case F_NEG_NUMBER:
      switch(opcode(1))
      {
      case F_NEGATE:
        /* NEG_NUMBER NEGATE : NUMBER ($1a) */
        {
          INT32 arg0=argument(0);
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert(F_NUMBER,arg0);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      case F_INDEX:
        /* NEG_NUMBER [$1a >= 0] INDEX: NEG_INT_INDEX ($1a) */
        if(argument(0) >= 0)
        {
          INT32 arg0=argument(0);
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert(F_NEG_INT_INDEX,arg0);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        /* NEG_NUMBER [$1a < 0] INDEX: POS_INT_INDEX (-$1a) */
        if(argument(0) < 0)
        {
          INT32 arg0=-argument(0);
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert(F_POS_INT_INDEX,arg0);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      }
      break;

    case F_POST_DEC_LOCAL:
      /* POST_DEC_LOCAL POP_VALUE : DEC_LOCAL_AND_POP ($1a) */
      if(F_POP_VALUE==opcode(1))
      {
        INT32 arg0=argument(0);
        copy_shared_string(current_file,instr(0)->file);
        current_line=instr(0)->line;
        pop_n_opcodes(2);
        insert(F_DEC_LOCAL_AND_POP,arg0);
        fifo_len+=1;
        free_string(current_file);
        debug();
        continue;
      }
      break;

    case F_LT:
      switch(opcode(1))
      {
      case F_BRANCH_WHEN_ZERO:
        /* LT BRANCH_WHEN_ZERO: BRANCH_WHEN_GE ($2a) */
        {
          INT32 arg0=argument(1);
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert(F_BRANCH_WHEN_GE,arg0);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      case F_NOT:
        /* LT NOT: GE */
        {
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert2(F_GE);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      case F_BRANCH_WHEN_NON_ZERO:
        /* LT BRANCH_WHEN_NON_ZERO: BRANCH_WHEN_LT ($2a) */
        {
          INT32 arg0=argument(1);
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert(F_BRANCH_WHEN_LT,arg0);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      }
      break;

    case F_MARK:
      /* MARK MARK: MARK2 */
      if(F_MARK==opcode(1))
      {
        copy_shared_string(current_file,instr(0)->file);
        current_line=instr(0)->line;
        pop_n_opcodes(2);
        insert2(F_MARK2);
        fifo_len+=1;
        free_string(current_file);
        debug();
        continue;
      }
      break;

    case F_NUMBER:
      switch(argument(0))
      {
      case 0:
        /* NUMBER(0) : CONST0 */
        {
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(1);
          insert2(F_CONST0);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      case -1:
        /* NUMBER(-1) : CONST_1 */
        {
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(1);
          insert2(F_CONST_1);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      case 1:
        /* NUMBER(1) : CONST1 */
        {
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(1);
          insert2(F_CONST1);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      default:
        switch(opcode(1))
        {
        case F_NEGATE:
          /* NUMBER NEGATE : NEG_NUMBER($1a) */
          {
            INT32 arg0=argument(0);
            copy_shared_string(current_file,instr(0)->file);
            current_line=instr(0)->line;
            pop_n_opcodes(2);
            insert(F_NEG_NUMBER,arg0);
            fifo_len+=1;
            free_string(current_file);
            debug();
            continue;
          }
          break;

        case F_INDEX:
          /* NUMBER [$1a < 0] INDEX: NEG_INT_INDEX (-$1a) */
          if(argument(0) < 0)
          {
            INT32 arg0=-argument(0);
            copy_shared_string(current_file,instr(0)->file);
            current_line=instr(0)->line;
            pop_n_opcodes(2);
            insert(F_NEG_INT_INDEX,arg0);
            fifo_len+=1;
            free_string(current_file);
            debug();
            continue;
          }
          /* NUMBER [$1a >= 0] INDEX: POS_INT_INDEX ($1a) */
          if(argument(0) >= 0)
          {
            INT32 arg0=argument(0);
            copy_shared_string(current_file,instr(0)->file);
            current_line=instr(0)->line;
            pop_n_opcodes(2);
            insert(F_POS_INT_INDEX,arg0);
            fifo_len+=1;
            free_string(current_file);
            debug();
            continue;
          }
          break;

        default:
          /* NUMBER (0x7fffffff) : BIGNUM */
          if((0x7fffffff)==argument(0))
          {
            copy_shared_string(current_file,instr(0)->file);
            current_line=instr(0)->line;
            pop_n_opcodes(1);
            insert2(F_BIGNUM);
            fifo_len+=1;
            free_string(current_file);
            debug();
            continue;
          }
          /* NUMBER [$1a < 0] : NEG_NUMBER (-$1a) */
          if(argument(0) < 0)
          {
            INT32 arg0=-argument(0);
            copy_shared_string(current_file,instr(0)->file);
            current_line=instr(0)->line;
            pop_n_opcodes(1);
            insert(F_NEG_NUMBER,arg0);
            fifo_len+=1;
            free_string(current_file);
            debug();
            continue;
          }
        }
      }
      break;

    case F_CONST0:
      switch(opcode(1))
      {
      case F_RETURN:
        /* CONST0 RETURN: RETURN_0 */
        {
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert2(F_RETURN_0);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      case F_ASSIGN_LOCAL_AND_POP:
        /* CONST0 ASSIGN_LOCAL_AND_POP : CLEAR_LOCAL($2a) */
        {
          INT32 arg0=argument(1);
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert(F_CLEAR_LOCAL,arg0);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      case F_NEGATE:
        /* CONST0 NEGATE : CONST0 */
        {
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert2(F_CONST0);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      case F_BRANCH_WHEN_ZERO:
        /* CONST0 BRANCH_WHEN_ZERO: BRANCH($2a) */
        {
          INT32 arg0=argument(1);
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert(F_BRANCH,arg0);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      case F_XOR:
        /* CONST0 XOR: */
        {
          pop_n_opcodes(2);
          continue;
        }
        break;

      case F_INDEX:
        /* CONST0 INDEX: POS_INT_INDEX (0) */
        {
          INT32 arg0=0;
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert(F_POS_INT_INDEX,arg0);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      case F_BRANCH_WHEN_NON_ZERO:
        /* CONST0 BRANCH_WHEN_NON_ZERO:  */
        {
          pop_n_opcodes(2);
          continue;
        }
        break;

      case F_SUBTRACT:
        /* CONST0 SUBTRACT: */
        {
          pop_n_opcodes(2);
          continue;
        }
        break;

      }
      break;

    case F_EQ:
      switch(opcode(1))
      {
      case F_BRANCH_WHEN_ZERO:
        /* EQ BRANCH_WHEN_ZERO: BRANCH_WHEN_NE ($2a) */
        {
          INT32 arg0=argument(1);
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert(F_BRANCH_WHEN_NE,arg0);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      case F_CONST0:
        /* EQ CONST0: NOT */
        {
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert2(F_NOT);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      case F_NOT:
        /* EQ NOT: NE */
        {
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert2(F_NE);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      case F_BRANCH_WHEN_NON_ZERO:
        /* EQ BRANCH_WHEN_NON_ZERO: BRANCH_WHEN_EQ ($2a) */
        {
          INT32 arg0=argument(1);
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert(F_BRANCH_WHEN_EQ,arg0);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      }
      break;

    case F_INC_LOCAL_AND_POP:
      /* INC_LOCAL_AND_POP LOCAL ($1a) : INC_LOCAL ($1a) */
      if(F_LOCAL==opcode(1) && (argument(0))==argument(1))
      {
        INT32 arg0=argument(0);
        copy_shared_string(current_file,instr(0)->file);
        current_line=instr(0)->line;
        pop_n_opcodes(2);
        insert(F_INC_LOCAL,arg0);
        fifo_len+=1;
        free_string(current_file);
        debug();
        continue;
      }
      break;

    case F_POP_VALUE:
      switch(opcode(1))
      {
      case F_POP_VALUE:
        /* POP_VALUE POP_VALUE : POP_N_ELEMS (2) */
        {
          INT32 arg0=2;
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert(F_POP_N_ELEMS,arg0);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      case F_POP_N_ELEMS:
        /* POP_VALUE POP_N_ELEMS : POP_N_ELEMS ($2a + 1) */
        {
          INT32 arg0=argument(1) + 1;
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert(F_POP_N_ELEMS,arg0);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      }
      break;

    case F_RETURN:
      /* RETURN !LABEL : RETURN */
      if(F_LABEL!=opcode(1))
      {
        copy_shared_string(current_file,instr(0)->file);
        current_line=instr(0)->line;
        pop_n_opcodes(2);
        insert2(F_RETURN);
        fifo_len+=1;
        free_string(current_file);
        debug();
        continue;
      }
      break;

    case F_STRING:
      /* STRING INDEX: STRING_INDEX ($1a) */
      if(F_INDEX==opcode(1))
      {
        INT32 arg0=argument(0);
        copy_shared_string(current_file,instr(0)->file);
        current_line=instr(0)->line;
        pop_n_opcodes(2);
        insert(F_STRING_INDEX,arg0);
        fifo_len+=1;
        free_string(current_file);
        debug();
        continue;
      }
      break;

    case F_POST_DEC:
      /* POST_DEC POP_VALUE: DEC_AND_POP */
      if(F_POP_VALUE==opcode(1))
      {
        copy_shared_string(current_file,instr(0)->file);
        current_line=instr(0)->line;
        pop_n_opcodes(2);
        insert2(F_DEC_AND_POP);
        fifo_len+=1;
        free_string(current_file);
        debug();
        continue;
      }
      break;

    case F_POST_INC:
      /* POST_INC POP_VALUE: INC_AND_POP */
      if(F_POP_VALUE==opcode(1))
      {
        copy_shared_string(current_file,instr(0)->file);
        current_line=instr(0)->line;
        pop_n_opcodes(2);
        insert2(F_INC_AND_POP);
        fifo_len+=1;
        free_string(current_file);
        debug();
        continue;
      }
      break;

    case F_LOCAL_LVALUE:
      switch(opcode(1))
      {
      case F_DEC_AND_POP:
        /* LOCAL_LVALUE DEC_AND_POP : DEC_LOCAL_AND_POP ($1a) */
        {
          INT32 arg0=argument(0);
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert(F_DEC_LOCAL_AND_POP,arg0);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      case F_POST_DEC:
        /* LOCAL_LVALUE POST_DEC : POST_DEC_LOCAL ($1a) */
        {
          INT32 arg0=argument(0);
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert(F_POST_DEC_LOCAL,arg0);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      case F_DEC:
        /* LOCAL_LVALUE DEC : DEC_LOCAL ($1a) */
        {
          INT32 arg0=argument(0);
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert(F_DEC_LOCAL,arg0);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      case F_INC_AND_POP:
        /* LOCAL_LVALUE INC_AND_POP : INC_LOCAL_AND_POP ($1a) */
        {
          INT32 arg0=argument(0);
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert(F_INC_LOCAL_AND_POP,arg0);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      case F_POST_INC:
        /* LOCAL_LVALUE POST_INC : POST_INC_LOCAL ($1a) */
        {
          INT32 arg0=argument(0);
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert(F_POST_INC_LOCAL,arg0);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      case F_INC:
        /* LOCAL_LVALUE INC : INC_LOCAL ($1a) */
        {
          INT32 arg0=argument(0);
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert(F_INC_LOCAL,arg0);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      }
      break;

    case F_CONST1:
      switch(opcode(1))
      {
      case F_NEGATE:
        /* CONST1 NEGATE : CONST_1 */
        {
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert2(F_CONST_1);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      case F_BRANCH_WHEN_ZERO:
        /* CONST1 BRANCH_WHEN_ZERO: */
        {
          pop_n_opcodes(2);
          continue;
        }
        break;

      case F_INDEX:
        /* CONST1 INDEX: POS_INT_INDEX (1) */
        {
          INT32 arg0=1;
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert(F_POS_INT_INDEX,arg0);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      case F_BRANCH_WHEN_NON_ZERO:
        /* CONST1 BRANCH_WHEN_NON_ZERO: BRANCH($2a) */
        {
          INT32 arg0=argument(1);
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert(F_BRANCH,arg0);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      case F_DIVIDE:
        /* CONST1 DIVIDE :  */
        {
          pop_n_opcodes(2);
          continue;
        }
        break;

      case F_MULTIPLY:
        /* CONST1 MULTIPLY :  */
        {
          pop_n_opcodes(2);
          continue;
        }
        break;

      }
      break;

    case F_NE:
      switch(opcode(1))
      {
      case F_BRANCH_WHEN_ZERO:
        /* NE BRANCH_WHEN_ZERO: BRANCH_WHEN_EQ ($2a) */
        {
          INT32 arg0=argument(1);
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert(F_BRANCH_WHEN_EQ,arg0);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      case F_NOT:
        /* NE NOT: EQ */
        {
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert2(F_EQ);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      case F_BRANCH_WHEN_NON_ZERO:
        /* NE BRANCH_WHEN_NON_ZERO: BRANCH_WHEN_NE ($2a) */
        {
          INT32 arg0=argument(1);
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert(F_BRANCH_WHEN_NE,arg0);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      }
      break;

    case F_ASSIGN_LOCAL:
      /* ASSIGN_LOCAL  POP_VALUE : ASSIGN_LOCAL_AND_POP($1a) */
      if(F_POP_VALUE==opcode(1))
      {
        INT32 arg0=argument(0);
        copy_shared_string(current_file,instr(0)->file);
        current_line=instr(0)->line;
        pop_n_opcodes(2);
        insert(F_ASSIGN_LOCAL_AND_POP,arg0);
        fifo_len+=1;
        free_string(current_file);
        debug();
        continue;
      }
      break;

    case F_GT:
      switch(opcode(1))
      {
      case F_BRANCH_WHEN_ZERO:
        /* GT BRANCH_WHEN_ZERO: BRANCH_WHEN_LE ($2a) */
        {
          INT32 arg0=argument(1);
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert(F_BRANCH_WHEN_LE,arg0);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      case F_NOT:
        /* GT NOT: LE */
        {
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert2(F_LE);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      case F_BRANCH_WHEN_NON_ZERO:
        /* GT BRANCH_WHEN_NON_ZERO: BRANCH_WHEN_GT ($2a) */
        {
          INT32 arg0=argument(1);
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert(F_BRANCH_WHEN_GT,arg0);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      }
      break;

    case F_CALL_LFUN:
      /* CALL_LFUN POP_VALUE : CALL_LFUN_AND_POP($1a) */
      if(F_POP_VALUE==opcode(1))
      {
        INT32 arg0=argument(0);
        copy_shared_string(current_file,instr(0)->file);
        current_line=instr(0)->line;
        pop_n_opcodes(2);
        insert(F_CALL_LFUN_AND_POP,arg0);
        fifo_len+=1;
        free_string(current_file);
        debug();
        continue;
      }
      break;

    case F_INC:
      /* INC POP_VALUE: INC_AND_POP */
      if(F_POP_VALUE==opcode(1))
      {
        copy_shared_string(current_file,instr(0)->file);
        current_line=instr(0)->line;
        pop_n_opcodes(2);
        insert2(F_INC_AND_POP);
        fifo_len+=1;
        free_string(current_file);
        debug();
        continue;
      }
      break;

    case F_ASSIGN_GLOBAL_AND_POP:
      /* ASSIGN_GLOBAL_AND_POP GLOBAL ($1a) : ASSIGN_GLOBAL ($1a) */
      if(F_GLOBAL==opcode(1) && (argument(0))==argument(1))
      {
        INT32 arg0=argument(0);
        copy_shared_string(current_file,instr(0)->file);
        current_line=instr(0)->line;
        pop_n_opcodes(2);
        insert(F_ASSIGN_GLOBAL,arg0);
        fifo_len+=1;
        free_string(current_file);
        debug();
        continue;
      }
      break;

    case F_POST_INC_LOCAL:
      /* POST_INC_LOCAL POP_VALUE : INC_LOCAL_AND_POP ($1a) */
      if(F_POP_VALUE==opcode(1))
      {
        INT32 arg0=argument(0);
        copy_shared_string(current_file,instr(0)->file);
        current_line=instr(0)->line;
        pop_n_opcodes(2);
        insert(F_INC_LOCAL_AND_POP,arg0);
        fifo_len+=1;
        free_string(current_file);
        debug();
        continue;
      }
      break;

    case F_ASSIGN_GLOBAL:
      /* ASSIGN_GLOBAL POP_VALUE : ASSIGN_GLOBAL_AND_POP($1a) */
      if(F_POP_VALUE==opcode(1))
      {
        INT32 arg0=argument(0);
        copy_shared_string(current_file,instr(0)->file);
        current_line=instr(0)->line;
        pop_n_opcodes(2);
        insert(F_ASSIGN_GLOBAL_AND_POP,arg0);
        fifo_len+=1;
        free_string(current_file);
        debug();
        continue;
      }
      break;

    case F_ASSIGN_LOCAL_AND_POP:
      /* ASSIGN_LOCAL_AND_POP LOCAL ($1a) : ASSIGN_LOCAL ($1a) */
      if(F_LOCAL==opcode(1) && (argument(0))==argument(1))
      {
        INT32 arg0=argument(0);
        copy_shared_string(current_file,instr(0)->file);
        current_line=instr(0)->line;
        pop_n_opcodes(2);
        insert(F_ASSIGN_LOCAL,arg0);
        fifo_len+=1;
        free_string(current_file);
        debug();
        continue;
      }
      /* ASSIGN_LOCAL_AND_POP LOCAL ($1a) RETURN : RETURN */
      if(F_LOCAL==opcode(1) && (argument(0))==argument(1) && F_RETURN==opcode(2))
      {
        copy_shared_string(current_file,instr(0)->file);
        current_line=instr(0)->line;
        pop_n_opcodes(3);
        insert2(F_RETURN);
        fifo_len+=1;
        free_string(current_file);
        debug();
        continue;
      }
      break;

    case F_RETURN_0:
      /* RETURN_0 !LABEL : RETURN_0 */
      if(F_LABEL!=opcode(1))
      {
        copy_shared_string(current_file,instr(0)->file);
        current_line=instr(0)->line;
        pop_n_opcodes(2);
        insert2(F_RETURN_0);
        fifo_len+=1;
        free_string(current_file);
        debug();
        continue;
      }
      break;

    case F_LOCAL:
      switch(opcode(1))
      {
      case F_SIZEOF:
        /* LOCAL SIZEOF: SIZEOF_LOCAL ($1a) */
        {
          INT32 arg0=argument(0);
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert(F_SIZEOF_LOCAL,arg0);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      case F_INDEX:
        /* LOCAL INDEX: LOCAL_INDEX ($1a) */
        {
          INT32 arg0=argument(0);
          copy_shared_string(current_file,instr(0)->file);
          current_line=instr(0)->line;
          pop_n_opcodes(2);
          insert(F_LOCAL_INDEX,arg0);
          fifo_len+=1;
          free_string(current_file);
          debug();
          continue;
        }
        break;

      }
      break;

    }
    advance();
  }
  for(eye=0;eye<len;eye++) free_string(instructions[eye].file);
  free((char *)instructions);
